void sensor_run() {

  if (millis() - previousMillis > interval)
  {

    tpulse1Sec = pulseCount;
    pulseCount = 0;


    tflowRate = ((1000.0 / (millis() - previousMillis)) * tpulse1Sec) / calibrationFactor;

    tflowMilliLitres = (tflowRate / 60) * 1000;
    tflowLitres = (tflowRate / 60);


    ttotalMilliLitres += tflowMilliLitres;
    ttotalLitres += tflowLitres;


    Serial.print("Total Flow rate: ");
    Serial.print(float(tflowRate));
    Serial.print("L/min");
    Serial.print("\t");

    Serial.print("Total Output Liquid Quantity: ");
    Serial.print(ttotalMilliLitres);
    Serial.print("mL / ");
    Serial.print(ttotalLitres);
    Serial.println("L");

    bpulse1Sec = pulseCount2;
    pulseCount2 = 0;


    bflowRate = ((1000.0 / (millis() - previousMillis)) * bpulse1Sec) / calibrationFactor;
    previousMillis = millis();


    bflowMilliLitres = (bflowRate / 60) * 1000;
    bflowLitres = (bflowRate / 60);


    btotalMilliLitres += bflowMilliLitres;
    btotalLitres += bflowLitres;


    Serial.print("Bathroom Flow rate: ");
    Serial.print(float(bflowRate));
    Serial.print("L/min");
    Serial.print("\t");

    Serial.print("Bathroom Output Liquid Quantity: ");
    Serial.print(btotalMilliLitres);
    Serial.print("mL / ");
    Serial.print(btotalLitres);
    Serial.println("L");
  }

  if (millis() - sendtime >= send_interval) {

    if (svrv.connect(svr, 80))
    {
      Serial.println("Sending Data");
      String postStr = apiKey;
      postStr += "&field2=";
      postStr += String(float(tflowRate));
      postStr += "&field1=";
      postStr += String(ttotalLitres);
      postStr += "&field3=";
      postStr += String(float(bflowRate));
      postStr += "&field4=";
      postStr += String(btotalLitres);
      postStr += "\r\n\r\n";

      svrv.print("POST /update HTTP/1.1\n");
      svrv.print("Host: api.thingspeak.com\n");
      svrv.print("Connection: close\n");
      svrv.print("X-THINGSPEAKAPIKEY: " + apiKey + "\n");
      svrv.print("Content-Type: application/x-www-form-urlencoded\n");
      svrv.print("Content-Length: ");
      svrv.print(postStr.length());
      svrv.print("\n\n");
      svrv.print(postStr);
    }
    svrv.stop();
    sendtime = millis();
  }

  if (valve_stat)
    digitalWrite(valve_pin, LOW);
  else
    digitalWrite(valve_pin, HIGH);
}
