# -*- coding: utf-8 -*-
"""
Created on Wed May 27 13:16:38 2020

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import csv
from fbprophet import Prophet
from fbprophet.plot import plot_plotly
import plotly.offline as py
import os
import plotly.graph_objects as go
class water_stat:
    
    def __init__(self):
        
        self.water_df = pd.read_csv('water_data.csv')
        self.m = Prophet(weekly_seasonality=False,yearly_seasonality=False)
        self.valid_house_nms = ['HOUSE_1','HOUSE_2','HOUSE_3','HOUSE_4','HOUSE_5','HOUSE_6',
                           'HOUSE_7','HOUSE_8','HOUSE_9','HOUSE_10','HOUSE_11','HOUSE_12',
                           'HOUSE_13','HOUSE_14','HOUSE_15','HOUSE_16','HOUSE_17','HOUSE_18',
                           'HOUSE_19','HOUSE_20','HOUSE_21','HOUSE_22','HOUSE_23','HOUSE_24',
                           'HOUSE_25','HOUSE_26','HOUSE_27','HOUSE_28','HOUSE_29','HOUSE_30']
        
    
    def Spaghetti(self):
        data = self.water_df.groupby('Connection No')
        dates= []
        
        for i in range(len(pd.to_datetime(data.get_group("HOUSE_1")['Reading Date']).dt.to_period('M'))):
            dates.append(str(pd.to_datetime(data.get_group("HOUSE_1")['Reading Date']).dt.to_period('M')[i]))
            

        #first 6 houses
        df=pd.DataFrame({'x': dates, 'HOUSE_1':data.get_group("HOUSE_1")['Consumption'].tolist(), 
                         'HOUSE_2':data.get_group("HOUSE_2")['Consumption'].tolist(),
                         'HOUSE_3':data.get_group("HOUSE_3")['Consumption'].tolist(),
                         'HOUSE_4':data.get_group("HOUSE_4")['Consumption'].tolist(),
                         'HOUSE_5':data.get_group("HOUSE_5")['Consumption'].tolist(),
                         'HOUSE_6':data.get_group("HOUSE_6")['Consumption'].tolist()})
        plt.style.use('seaborn-darkgrid')
        plt.figure(figsize=(18,10))
        palette = plt.get_cmap('Set1')
        num=0
        for column in df.drop('x', axis=1):
            num+=1
            plt.plot(df['x'], df[column], marker='', color=palette(num), linewidth=1, alpha=0.9, label=column)
    
        plt.legend(loc=2, ncol=2)
        plt.title("Monthly used Units of First six Houses", loc='left', fontsize=12, fontweight=0, color='orange')
        plt.xlabel("Time")
        plt.xticks(rotation=90)
        plt.ylabel("Units")
        
        
        # second 6 houses
        plt.style.use('seaborn-darkgrid')
        df=pd.DataFrame({'x': dates,'HOUSE_7':data.get_group("HOUSE_7")['Consumption'].tolist(),
                         'HOUSE_8':data.get_group("HOUSE_8")['Consumption'].tolist(),
                         'HOUSE_9':data.get_group("HOUSE_9")['Consumption'].tolist(),
                         'HOUSE_10':data.get_group("HOUSE_10")['Consumption'].tolist(),
                         'HOUSE_11':data.get_group("HOUSE_11")['Consumption'].tolist(),
                         'HOUSE_12':data.get_group("HOUSE_12")['Consumption'].tolist() })
        plt.style.use('seaborn-darkgrid')
        plt.figure(figsize=(18,10))
        palette = plt.get_cmap('Set1')
        num=0
        for column in df.drop('x', axis=1):
            num+=1
            plt.plot(df['x'], df[column], marker='', color=palette(num), linewidth=1, alpha=0.9, label=column)
    
        plt.legend(loc=2, ncol=2)
        plt.title("Monthly used Units of Second six Houses", loc='left', fontsize=12, fontweight=0, color='orange')
        plt.xlabel("Time")
        plt.xticks(rotation=90)
        plt.ylabel("Units")
        
        # third 6 houses
        plt.style.use('seaborn-darkgrid')
        df=pd.DataFrame({'x': dates,'HOUSE_13':data.get_group("HOUSE_13")['Consumption'].tolist(),
                         'HOUSE_14':data.get_group("HOUSE_14")['Consumption'].tolist(),
                         'HOUSE_15':data.get_group("HOUSE_15")['Consumption'].tolist(),
                         'HOUSE_16':data.get_group("HOUSE_16")['Consumption'].tolist(),
                         'HOUSE_17':data.get_group("HOUSE_17")['Consumption'].tolist(),
                         'HOUSE_18':data.get_group("HOUSE_18")['Consumption'].tolist()})
        plt.style.use('seaborn-darkgrid')
        plt.figure(figsize=(18,10))
        palette = plt.get_cmap('Set1')
        num=0
        for column in df.drop('x', axis=1):
            num+=1
            plt.plot(df['x'], df[column], marker='', color=palette(num), linewidth=1, alpha=0.9, label=column)
    
        plt.legend(loc=2, ncol=2)
        plt.title("Monthly used Units of Third six Houses", loc='left', fontsize=12, fontweight=0, color='orange')
        plt.xlabel("Time")
        plt.xticks(rotation=90)
        plt.ylabel("Units")
        
        # fourth 6 houses
        plt.style.use('seaborn-darkgrid')
        df=pd.DataFrame({'x': dates,'HOUSE_19':data.get_group("HOUSE_19")['Consumption'].tolist(),
                         'HOUSE_20':data.get_group("HOUSE_20")['Consumption'].tolist(),
                         'HOUSE_21':data.get_group("HOUSE_21")['Consumption'].tolist(),
                         'HOUSE_22':data.get_group("HOUSE_22")['Consumption'].tolist(),
                         'HOUSE_23':data.get_group("HOUSE_23")['Consumption'].tolist(),
                         'HOUSE_24':data.get_group("HOUSE_24")['Consumption'].tolist()})
        plt.style.use('seaborn-darkgrid')
        plt.figure(figsize=(18,10))
        palette = plt.get_cmap('Set1')
        num=0
        for column in df.drop('x', axis=1):
            num+=1
            plt.plot(df['x'], df[column], marker='', color=palette(num), linewidth=1, alpha=0.9, label=column)
    
        plt.legend(loc=2, ncol=2)
        plt.title("Monthly used Units of Fourth six Houses", loc='left', fontsize=12, fontweight=0, color='orange')
        plt.xlabel("Time")
        plt.xticks(rotation=90)
        plt.ylabel("Units")
        
        
        
        # fifth 6 houses
        plt.style.use('seaborn-darkgrid')
        df=pd.DataFrame({'x': dates,'HOUSE_25':data.get_group("HOUSE_25")['Consumption'].tolist(),
                         'HOUSE_26':data.get_group("HOUSE_26")['Consumption'].tolist(),
                         'HOUSE_27':data.get_group("HOUSE_27")['Consumption'].tolist(),
                         'HOUSE_28':data.get_group("HOUSE_28")['Consumption'].tolist(),
                         'HOUSE_29':data.get_group("HOUSE_29")['Consumption'].tolist(),
                         'HOUSE_30':data.get_group("HOUSE_30")['Consumption'].tolist()})
        plt.style.use('seaborn-darkgrid')
        plt.figure(figsize=(18,10))
        palette = plt.get_cmap('Set1')
        num=0
        for column in df.drop('x', axis=1):
            num+=1
            plt.plot(df['x'], df[column], marker='', color=palette(num), linewidth=1, alpha=0.9, label=column)
    
        plt.legend(loc=2, ncol=2)
        plt.title("Monthly used Units of Fifth six Houses", loc='left', fontsize=12, fontweight=0, color='orange')
        plt.xlabel("Time")
        plt.xticks(rotation=90)
        plt.ylabel("Units")
        
        
    def predict_next_month_unit_of_a_house(self,house_name):
        
        data = self.water_df.groupby('Connection No')
        
        
        
        if house_name not in self.valid_house_nms:
            return -1
        
        self.temp_CSV(data,house_name)
        df_new = pd.read_csv('temp.csv')  
        self.m.fit(df_new)
        future = self.m.make_future_dataframe(periods=1)
        forecast = self.m.predict(future)
        forecast[['ds', 'yhat', 'yhat_lower', 'yhat_upper']].tail()
        f_cast = forecast['yhat'].tail(1)
        f_cast = f_cast.tolist()
        self.remove_temp_files()
        
        
        self.m.plot(forecast)
        self.m.plot_components(forecast)
        py.init_notebook_mode()
        fig = plot_plotly(self.m, forecast) 
        py.iplot(fig)
        
        return f_cast[0]
        
    
    def temp_CSV(self,data,house_id):
        
        
        data_frame = data.get_group(house_id)
        
        date = pd.to_datetime(data.get_group("HOUSE_1")['Reading Date']).dt.to_period('M').tolist()
        #date = data_frame['Reading Date'].tolist()
        units = data_frame['Consumption'].tolist()

        with open('temp.csv','w',newline='') as file:
            writer = csv.writer(file)
            writer.writerow(['ds','y'])
            
            for i in range(len(date)):
                writer.writerow([date[i],units[i]])
                
    def remove_temp_files(self):
        
        if os.path.exists("temp.csv"):
            os.remove('temp.csv')
            
    def lane_water_mean_consumption_per_house(self):
        
        data = self.water_df.groupby('Connection No')
        labels = []
        values = []
        for names in self.valid_house_nms:
            #mean_vals[names] = data.get_group(names)['Consumption'].mean()
            labels.append(names)
            values.append(data.get_group(names)['Consumption'].mean())
            
        fig = plt.figure(figsize=(13, 20))
        ax = fig.add_axes([0,0,1,1])
        ax.axis('equal')
        ax.pie(values,labels = labels,autopct='%1.1f%%',startangle=140, pctdistance=0.8, radius = 0.8)
        
        plt.show()
        
    def predict_next_month_bill(self,house_no):
        
        predicted_unit_usage = round(x.predict_next_month_unit_of_a_house(house_no))
        unit_sets = int(predicted_unit_usage/5)
        remain_units = predicted_unit_usage % 5
        
        
        

x = water_stat()
x.Spaghetti()
print("Next month units: {}".format(round(x.predict_next_month_unit_of_a_house("HOUSE_17"))))
x.lane_water_mean_consumption_per_house()

